"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _types = require("./types");

var _shapedTree = require("./shapedTree");

var _array = require("./utils/array");

var _Form = require("./Form");

var _formState2 = require("./formState");

var _alwaysValid = _interopRequireDefault(require("./alwaysValid"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function makeLinks(path, formState, onChildChange, onChildBlur) {
  var _formState = _slicedToArray(formState, 1),
      oldValue = _formState[0];

  return oldValue.map(function (x, i) {
    return {
      formState: (0, _formState2.arrayChild)(i, formState),
      onChange: function onChange(childFormState) {
        onChildChange(i, childFormState);
      },
      onBlur: function onBlur(childTree) {
        onChildBlur(i, childTree);
      },
      path: [].concat(_toConsumableArray(path), [{
        type: "array",
        index: i
      }])
    };
  });
}

var ArrayField =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ArrayField, _React$Component);

  function ArrayField() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ArrayField);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ArrayField)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "context", void 0);

    _defineProperty(_assertThisInitialized(_this), "validationFnOps", (0, _Form.validationFnNoOps)());

    _defineProperty(_assertThisInitialized(_this), "_handleChildChange", function (index, newChild) {
      var newFormState = (0, _formState2.replaceArrayChild)(index, newChild, _this.props.link.formState);
      var oldValue = _this.props.link.formState[0];
      var newValue = newFormState[0];

      var customValue = _this.props.customChange && _this.props.customChange(oldValue, newValue);

      var validatedFormState;

      if (customValue) {
        // A custom change occurred, which means the whole array needs to be
        // revalidated.
        var customChangedFormState = [customValue, newFormState[1]];
        validatedFormState = _this.context.applyCustomChangeToTree(_this.props.link.path, customChangedFormState);
      } else {
        validatedFormState = _this.context.applyChangeToNode(_this.props.link.path, newFormState);
      }

      _this.props.link.onChange(validatedFormState);
    });

    _defineProperty(_assertThisInitialized(_this), "_handleChildBlur", function (index, childTree) {
      var _this$props$link$form = _slicedToArray(_this.props.link.formState, 2),
          _ = _this$props$link$form[0],
          tree = _this$props$link$form[1];

      _this.props.link.onBlur((0, _shapedTree.mapRoot)(_formState2.setExtrasTouched, (0, _shapedTree.dangerouslyReplaceArrayChild)(index, childTree, tree)));
    });

    _defineProperty(_assertThisInitialized(_this), "_addChildField", function (index, childValue) {
      var _this$props$link$form2 = _slicedToArray(_this.props.link.formState, 2),
          oldValue = _this$props$link$form2[0],
          oldTree = _this$props$link$form2[1];

      var cleanNode = {
        errors: _types.cleanErrors,
        meta: _types.cleanMeta
      };
      var newValue = (0, _array.insertAt)(index, childValue, oldValue);
      var newTree = (0, _shapedTree.dangerouslySetChildren)((0, _array.insertAt)(index, (0, _shapedTree.treeFromValue)(childValue, cleanNode), (0, _shapedTree.shapedArrayChildren)(oldTree)), oldTree);

      _this._validateThenApplyChange([newValue, newTree]);
    });

    _defineProperty(_assertThisInitialized(_this), "_addChildFields", function (spans) {
      var _this$props$link$form3 = _slicedToArray(_this.props.link.formState, 2),
          oldValue = _this$props$link$form3[0],
          oldTree = _this$props$link$form3[1];

      var cleanNode = {
        errors: _types.cleanErrors,
        meta: _types.cleanMeta
      };
      var newValue = (0, _array.insertSpans)(spans, oldValue);
      var newNodeSpans = spans.map(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            index = _ref2[0],
            content = _ref2[1];

        return [index, content.map(function (v) {
          return (0, _shapedTree.treeFromValue)(v, cleanNode);
        })];
      });
      var newTree = (0, _shapedTree.dangerouslySetChildren)((0, _array.insertSpans)(newNodeSpans, (0, _shapedTree.shapedArrayChildren)(oldTree)), oldTree);

      _this._validateThenApplyChange([newValue, newTree]);
    });

    _defineProperty(_assertThisInitialized(_this), "_filterChildFields", function (predicate) {
      var _this$props$link$form4 = _slicedToArray(_this.props.link.formState, 2),
          oldValue = _this$props$link$form4[0],
          oldTree = _this$props$link$form4[1];

      var zipped = (0, _array.zip)(oldValue, (0, _shapedTree.shapedArrayChildren)(oldTree));

      var _unzip = (0, _array.unzip)(zipped.filter(function (_ref3, i, arr) {
        var _ref4 = _slicedToArray(_ref3, 1),
            value = _ref4[0];

        return predicate(value, i, arr.map(function (_ref5) {
          var _ref6 = _slicedToArray(_ref5, 1),
              v = _ref6[0];

          return v;
        }));
      })),
          _unzip2 = _slicedToArray(_unzip, 2),
          newValue = _unzip2[0],
          newChildren = _unzip2[1];

      var newTree = (0, _shapedTree.dangerouslySetChildren)(newChildren, oldTree);

      _this._validateThenApplyChange([newValue, newTree]);
    });

    _defineProperty(_assertThisInitialized(_this), "_modifyChildFields", function (_ref7) {
      var insertSpans = _ref7.insertSpans,
          filterPredicate = _ref7.filterPredicate;

      var _this$props$link$form5 = _slicedToArray(_this.props.link.formState, 2),
          oldValue = _this$props$link$form5[0],
          oldTree = _this$props$link$form5[1];

      var cleanNode = {
        errors: _types.cleanErrors,
        meta: _types.cleanMeta
      }; // TODO(zach): there's a less complicated, more functorial way to do this
      // augment, then unaugment

      var zipped = (0, _array.zip)(oldValue, (0, _shapedTree.shapedArrayChildren)(oldTree)); // augment the spans with fresh nodes

      var augmentedSpans = insertSpans !== undefined ? insertSpans.map(function (_ref8) {
        var _ref9 = _slicedToArray(_ref8, 2),
            index = _ref9[0],
            contents = _ref9[1];

        return [index, contents.map(function (v) {
          return [v, (0, _shapedTree.treeFromValue)(v, cleanNode)];
        })];
      }) : undefined; // augment the predicate to work on formstates

      var augmentedPredicate = filterPredicate !== undefined ? function (_ref10, i, arr) {
        var _ref11 = _slicedToArray(_ref10, 2),
            v = _ref11[0],
            _ = _ref11[1];

        return filterPredicate(v, i, arr.map(function (_ref12) {
          var _ref13 = _slicedToArray(_ref12, 2),
              v = _ref13[0],
              _ = _ref13[1];

          return v;
        }));
      } : undefined;

      var _unzip3 = (0, _array.unzip)((0, _array.modify)({
        insertSpans: augmentedSpans,
        filterPredicate: augmentedPredicate
      }, zipped)),
          _unzip4 = _slicedToArray(_unzip3, 2),
          newValue = _unzip4[0],
          newChildren = _unzip4[1];

      var newTree = (0, _shapedTree.dangerouslySetChildren)(newChildren, oldTree);

      _this._validateThenApplyChange([newValue, newTree]);
    });

    _defineProperty(_assertThisInitialized(_this), "_removeChildField", function (index) {
      var _this$props$link$form6 = _slicedToArray(_this.props.link.formState, 2),
          oldValue = _this$props$link$form6[0],
          oldTree = _this$props$link$form6[1];

      var newValue = (0, _array.removeAt)(index, oldValue);
      var newTree = (0, _shapedTree.dangerouslySetChildren)((0, _array.removeAt)(index, (0, _shapedTree.shapedArrayChildren)(oldTree)), oldTree);

      _this._validateThenApplyChange([newValue, newTree]);
    });

    _defineProperty(_assertThisInitialized(_this), "_moveChildField", function (from, to) {
      var _this$props$link$form7 = _slicedToArray(_this.props.link.formState, 2),
          oldValue = _this$props$link$form7[0],
          oldTree = _this$props$link$form7[1];

      var newValue = (0, _array.moveFromTo)(from, to, oldValue);
      var newTree = (0, _shapedTree.dangerouslySetChildren)((0, _array.moveFromTo)(from, to, (0, _shapedTree.shapedArrayChildren)(oldTree)), oldTree);

      _this._validateThenApplyChange([newValue, newTree]);
    });

    return _this;
  }

  _createClass(ArrayField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.validationFnOps = this.context.registerValidation(this.props.link.path, this.props.validation);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.validationFnOps.replace(this.props.validation);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.validationFnOps.unregister();
      this.validationFnOps = (0, _Form.validationFnNoOps)();
    }
  }, {
    key: "_validateThenApplyChange",
    value: function _validateThenApplyChange(formState) {
      var validatedFormState = this.context.applyChangeToNode(this.props.link.path, formState);
      this.props.link.onChange(validatedFormState);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props$link = this.props.link,
          formState = _this$props$link.formState,
          path = _this$props$link.path;
      var shouldShowError = this.context.shouldShowError;
      var links = makeLinks(path, formState, this._handleChildChange, this._handleChildBlur);
      return React.createElement(React.Fragment, null, this.props.children(links, {
        addField: this._addChildField,
        removeField: this._removeChildField,
        moveField: this._moveChildField,
        addFields: this._addChildFields,
        filterFields: this._filterChildFields,
        modifyFields: this._modifyChildFields
      }, {
        touched: (0, _formState2.getExtras)(formState).meta.touched,
        changed: (0, _formState2.getExtras)(formState).meta.changed,
        shouldShowErrors: shouldShowError((0, _formState2.getExtras)(formState).meta),
        unfilteredErrors: (0, _formState2.flatRootErrors)(formState),
        asyncValidationInFlight: false,
        // no validations on Form
        valid: (0, _formState2.isValid)(formState),
        value: formState[0]
      }));
    }
  }]);

  return ArrayField;
}(React.Component);

exports.default = ArrayField;

_defineProperty(ArrayField, "defaultProps", {
  validation: _alwaysValid.default
});

_defineProperty(ArrayField, "contextType", _Form.FormContext);