"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startsWith = startsWith;
exports.encodePath = encodePath;
exports.decodePath = decodePath;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * A path suitable for use as a key in a Map.
 *
 * Right now just serialized to string, but this is hidden from users of this
 * module with an opaque type.
 *
 * 
 */
function startsWith(path, prefix) {
  return path.startsWith(prefix);
}

function encodePath(path) {
  return "/" + path.map(function (p) {
    if (p.type === "object") {
      return "o>".concat(p.key);
    } else if (p.type === "array") {
      return "a>".concat(p.index);
    } else {
      p.type; // eslint-disable-line no-unused-expressions

      throw new Error("Bad path type ".concat(p.type));
    }
  }).join("/");
}

function decodePath(s) {
  return s.split("/").filter(function (x) {
    return x !== "";
  }).map(function (s) {
    var _s$split = s.split(">"),
        _s$split2 = _slicedToArray(_s$split, 2),
        type = _s$split2[0],
        val = _s$split2[1];

    if (type === "o") {
      return {
        type: "object",
        key: val
      };
    } else if (type === "a") {
      return {
        type: "array",
        index: parseInt(val, 10)
      };
    } else {
      throw new Error("Bad encoded path type '".concat(type, "' for path '").concat(s, "'"));
    }
  });
}