"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ErrorsHelper;

var React = _interopRequireWildcard(require("react"));

var _Form = require("./Form");

var _formState = require("./formState");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function flattenErrors(errors) {
  var flatErrors = [];

  if (errors.client !== "pending") {
    flatErrors = flatErrors.concat(errors.client);
  }

  if (errors.external !== "unchecked") {
    flatErrors = flatErrors.concat(errors.external);
  }

  return flatErrors;
}

function ErrorsHelper(props) {
  var _getExtras = (0, _formState.getExtras)(props.link.formState),
      errors = _getExtras.errors,
      meta = _getExtras.meta;

  var flattened = flattenErrors(errors);
  var formContext = React.useContext(_Form.FormContext);
  var shouldShowErrors = formContext.shouldShowError(meta);
  return props.children({
    shouldShowErrors: shouldShowErrors,
    client: errors.client,
    external: errors.external,
    flattened: flattened
  });
}