"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _shapedTree = require("./shapedTree");

var _Form = require("./Form");

var _formState2 = require("./formState");

var _alwaysValid = _interopRequireDefault(require("./alwaysValid"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getErrors(errors) {
  var flatErrors = [];

  if (errors.client !== "pending") {
    flatErrors = flatErrors.concat(errors.client);
  }

  if (errors.external !== "unchecked") {
    flatErrors = flatErrors.concat(errors.external);
  }

  return flatErrors;
}

var Field =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Field, _React$Component);

  function Field() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Field);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Field)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "context", void 0);

    _defineProperty(_assertThisInitialized(_this), "validationFnOps", (0, _Form.validationFnNoOps)());

    _defineProperty(_assertThisInitialized(_this), "onChange", function (newValue) {
      var _this$props$link = _this.props.link,
          path = _this$props$link.path,
          _this$props$link$form = _slicedToArray(_this$props$link.formState, 2),
          _ = _this$props$link$form[0],
          oldTree = _this$props$link$form[1],
          onChange = _this$props$link.onChange;

      var newFormState = _this.context.applyChangeToNode(path, [newValue, oldTree]);

      onChange(newFormState);
    });

    _defineProperty(_assertThisInitialized(_this), "onBlur", function () {
      var _this$props$link$form2 = _slicedToArray(_this.props.link.formState, 2),
          _ = _this$props$link$form2[0],
          tree = _this$props$link$form2[1];

      _this.props.link.onBlur( // TODO(zach): Not sure if we should blow away external errors here
      (0, _shapedTree.mapRoot)(_formState2.setExtrasTouched, tree));
    });

    return _this;
  }

  _createClass(Field, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.validationFnOps = this.context.registerValidation(this.props.link.path, this.props.validation);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.validationFnOps.replace(this.props.validation);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.validationFnOps.unregister();
      this.validationFnOps = (0, _Form.validationFnNoOps)();
    }
  }, {
    key: "render",
    value: function render() {
      var formState = this.props.link.formState;

      var _formState = _slicedToArray(formState, 1),
          value = _formState[0];

      var _getExtras = (0, _formState2.getExtras)(formState),
          meta = _getExtras.meta,
          errors = _getExtras.errors;

      var shouldShowError = this.context.shouldShowError;
      var flatErrors = this.context.shouldShowError(meta) ? getErrors(errors) : [];
      return this.props.children(value, flatErrors, this.onChange, this.onBlur, {
        touched: meta.touched,
        changed: meta.changed,
        shouldShowErrors: shouldShowError(meta),
        unfilteredErrors: getErrors(errors),
        asyncValidationInFlight: false,
        // no validations on Form
        valid: (0, _formState2.isValid)(formState),
        value: value
      });
    }
  }]);

  return Field;
}(React.Component);

exports.default = Field;

_defineProperty(Field, "defaultProps", {
  validation: _alwaysValid.default
});

_defineProperty(Field, "contextType", _Form.FormContext);