"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _Form = require("./Form");

var _formState2 = require("./formState");

var _shapedTree = require("./shapedTree");

var _alwaysValid = _interopRequireDefault(require("./alwaysValid"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function makeLinks(path, formState, onChildChange, onChildBlur) {
  var _formState = _slicedToArray(formState, 1),
      value = _formState[0];

  return Object.keys(value).reduce(function (memo, k) {
    var l = {
      formState: (0, _formState2.objectChild)(k, formState),
      onChange: function onChange(childFormState) {
        onChildChange(k, childFormState);
      },
      onBlur: function onBlur(childTree) {
        onChildBlur(k, childTree);
      },
      path: [].concat(_toConsumableArray(path), [{
        type: "object",
        key: k
      }])
    };
    memo[k] = l;
    return _objectSpread({}, memo, _defineProperty({}, k, l));
  }, {});
}

var ObjectField =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ObjectField, _React$Component);

  function ObjectField() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ObjectField);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ObjectField)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "context", void 0);

    _defineProperty(_assertThisInitialized(_this), "validationFnOps", (0, _Form.validationFnNoOps)());

    _defineProperty(_assertThisInitialized(_this), "_handleChildChange", function (key, newChild) {
      var newFormState = (0, _formState2.replaceObjectChild)(key, newChild, _this.props.link.formState);
      var oldValue = _this.props.link.formState[0];
      var newValue = newFormState[0];

      var customValue = _this.props.customChange && _this.props.customChange(oldValue, newValue);

      var validatedFormState;

      if (customValue) {
        // A custom change occurred, which means the whole object needs to be
        // revalidated.
        var customChangedFormState = [customValue, newFormState[1]];
        validatedFormState = _this.context.applyCustomChangeToTree(_this.props.link.path, customChangedFormState);
      } else {
        validatedFormState = _this.context.applyChangeToNode(_this.props.link.path, newFormState);
      }

      _this.props.link.onChange(validatedFormState);
    });

    _defineProperty(_assertThisInitialized(_this), "_handleChildBlur", function (key, childTree) {
      var _this$props$link$form = _slicedToArray(_this.props.link.formState, 2),
          _ = _this$props$link$form[0],
          tree = _this$props$link$form[1];

      _this.props.link.onBlur((0, _shapedTree.mapRoot)(_formState2.setExtrasTouched, (0, _shapedTree.dangerouslyReplaceObjectChild)(key, childTree, tree)));
    });

    return _this;
  }

  _createClass(ObjectField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.validationFnOps = this.context.registerValidation(this.props.link.path, this.props.validation);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.validationFnOps.replace(this.props.validation);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.validationFnOps.unregister();
      this.validationFnOps = (0, _Form.validationFnNoOps)();
    }
  }, {
    key: "render",
    value: function render() {
      var formState = this.props.link.formState;
      var shouldShowError = this.context.shouldShowError;
      var links = makeLinks(this.props.link.path, this.props.link.formState, this._handleChildChange, this._handleChildBlur);
      return React.createElement(React.Fragment, null, this.props.children(links, {
        touched: (0, _formState2.getExtras)(formState).meta.touched,
        changed: (0, _formState2.getExtras)(formState).meta.changed,
        shouldShowErrors: shouldShowError((0, _formState2.getExtras)(formState).meta),
        unfilteredErrors: (0, _formState2.flatRootErrors)(formState),
        asyncValidationInFlight: false,
        // no validations on Form
        valid: (0, _formState2.isValid)(formState),
        value: formState[0]
      }));
    }
  }]);

  return ObjectField;
}(React.Component);

exports.default = ObjectField;

_defineProperty(ObjectField, "contextType", _Form.FormContext);

_defineProperty(ObjectField, "_contextType", _Form.FormContext);

_defineProperty(ObjectField, "defaultProps", {
  validation: _alwaysValid.default
});