"use strict";

var React = _interopRequireWildcard(require("react"));

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

var _feedbackStrategies = _interopRequireDefault(require("../feedbackStrategies"));

var _Form = _interopRequireWildcard(require("../Form"));

var _ObjectField = _interopRequireDefault(require("../ObjectField"));

var _ArrayField = _interopRequireDefault(require("../ArrayField"));

var _Field = _interopRequireDefault(require("../Field"));

var _tools = require("./tools");

var _TestField = _interopRequireWildcard(require("./TestField"));

var _LinkTap = _interopRequireDefault(require("../testutils/LinkTap"));

var _shapedTree = require("../shapedTree");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var NaughtyRenderingInput =
/*#__PURE__*/
function (_React$Component) {
  _inherits(NaughtyRenderingInput, _React$Component);

  function NaughtyRenderingInput() {
    _classCallCheck(this, NaughtyRenderingInput);

    return _possibleConstructorReturn(this, _getPrototypeOf(NaughtyRenderingInput).apply(this, arguments));
  }

  _createClass(NaughtyRenderingInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.onChange("hello from cDM()");
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return NaughtyRenderingInput;
}(React.Component);

function NaughtyRenderingField(props) {
  return React.createElement(_Field.default, props, function (value, errors, onChange, onBlur) {
    return React.createElement(NaughtyRenderingInput, {
      value: value,
      errors: errors,
      onChange: onChange,
      onBlur: onBlur
    });
  });
}

function expectMetaTouched(meta, value) {
  expect(meta).toEqual(expect.objectContaining({
    touched: value,
    changed: value
  }));
}

describe("Form", function () {
  describe("validations", function () {
    it("runs validations", function () {
      var objectValidation = jest.fn(function () {
        return [];
      });
      var arrayValidation = jest.fn(function () {
        return [];
      });
      var arrayElValidation = jest.fn(function () {
        return [];
      });
      var fieldValidation = jest.fn(function () {
        return [];
      });

      _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          a: ["1", "2"],
          s: "string"
        }
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link,
          validation: objectValidation
        }, function (links) {
          return React.createElement(React.Fragment, null, React.createElement(_ArrayField.default, {
            link: links.a,
            validation: arrayValidation
          }, function (links) {
            return links.map(function (link, i) {
              return React.createElement(_TestField.default, {
                key: i,
                link: link,
                validation: arrayElValidation
              });
            });
          }), React.createElement(_TestField.default, {
            link: links.s,
            validation: fieldValidation
          }));
        });
      }));

      expect(objectValidation).toHaveBeenCalledTimes(1);
      expect(objectValidation).toHaveBeenCalledWith({
        a: ["1", "2"],
        s: "string"
      });
      expect(arrayValidation).toHaveBeenCalledTimes(1);
      expect(arrayValidation).toHaveBeenCalledWith(["1", "2"]);
      expect(arrayElValidation).toHaveBeenCalledTimes(2);
      expect(arrayElValidation).toHaveBeenCalledWith("1");
      expect(arrayElValidation).toHaveBeenCalledWith("2");
      expect(fieldValidation).toHaveBeenCalledTimes(1);
      expect(fieldValidation).toHaveBeenCalledWith("string");
    });
    it("sets validation information on formState", function () {
      var objectValidation = jest.fn(function () {
        return ["object error"];
      });
      var arrayValidation = jest.fn(function () {
        return ["array", "error"];
      });
      var arrayElValidation = jest.fn(function (s) {
        return ["error ".concat(s)];
      });
      var fieldValidation = jest.fn(function () {
        return [];
      });

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          a: ["1", "2"],
          s: "string"
        }
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link,
          validation: objectValidation
        }, function (links) {
          return React.createElement(React.Fragment, null, React.createElement(_ArrayField.default, {
            link: links.a,
            validation: arrayValidation
          }, function (links) {
            return links.map(function (link, i) {
              return React.createElement(_TestField.default, {
                key: i,
                link: link,
                validation: arrayElValidation
              });
            });
          }), React.createElement(_TestField.default, {
            link: links.s,
            validation: fieldValidation
          }));
        });
      }));

      var formState = renderer.root.findByType(_ObjectField.default).instance.props.link.formState;
      var node = formState[1];
      expect(node.data.errors.client).toEqual(["object error"]);
      expectMetaTouched(node.data.meta, false);
      expect(node.data.meta.succeeded).toBe(false);
      node = node.children.a;
      expect(node.data.errors.client).toEqual(["array", "error"]);
      expectMetaTouched(node.data.meta, false);
      expect(node.data.meta.succeeded).toBe(false);
      var child0 = node.children[0];
      expect(child0.data.errors.client).toEqual(["error 1"]);
      expectMetaTouched(node.data.meta, false);
      expect(node.data.meta.succeeded).toBe(false);
      var child1 = node.children[1];
      expect(child1.data.errors.client).toEqual(["error 2"]);
      expectMetaTouched(node.data.meta, false);
      expect(node.data.meta.succeeded).toBe(false);
      node = formState[1].children.s;
      expect(node.data.errors.client).toEqual([]);
      expectMetaTouched(node.data.meta, false);
      expect(node.data.meta.succeeded).toBe(true);
    });
    it("treats no validation as always passing", function () {
      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          a: ["1", "2"],
          s: "string"
        }
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link
        }, function (links) {
          return React.createElement(React.Fragment, null, React.createElement(_ArrayField.default, {
            link: links.a
          }, function (links) {
            return links.map(function (link, i) {
              return React.createElement(_TestField.default, {
                key: i,
                link: link
              });
            });
          }), React.createElement(_TestField.default, {
            link: links.s
          }));
        });
      }));

      var formState = renderer.root.findByType(_ObjectField.default).instance.props.link.formState;
      var node = formState[1];
      expect(node.data.errors.client).toEqual([]);
      expect(node.data.meta.succeeded).toBe(true);
      node = node.children.a;
      expect(node.data.errors.client).toEqual([]);
      expect(node.data.meta.succeeded).toBe(true);
      var child0 = node.children[0];
      expect(child0.data.errors.client).toEqual([]);
      expect(child0.data.meta.succeeded).toBe(true);
      var child1 = node.children[1];
      expect(child1.data.errors.client).toEqual([]);
      expect(child1.data.meta.succeeded).toBe(true);
      node = formState[1].children.s;
      expect(node.data.errors.client).toEqual([]);
      expect(node.data.meta.succeeded).toBe(true);
    });
    it("validates newly mounted Fields", function () {
      function expectClientErrors(link) {
        var tree = link.formState[1];
        return expect((0, _shapedTree.forgetShape)(tree).data.errors.client);
      }

      var renderFn = jest.fn(function () {
        return null;
      });
      var validationA = jest.fn(function () {
        return ["error a"];
      });
      var validationB = jest.fn(function () {
        return ["error b"];
      });

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          key: "hello"
        }
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link
        }, function (link) {
          return React.createElement(React.Fragment, null, React.createElement(_LinkTap.default, {
            link: link.key
          }, renderFn), React.createElement(_TestField.default, {
            link: link.key,
            validation: validationA
          }));
        });
      }));

      expect(renderFn).toHaveBeenCalledTimes(2);
      var link, node; // Initial render

      link = renderFn.mock.calls[0][0]; // Note that here we expose "pending" as part of our API...
      // TODO(dmnd): It'd be nice if we could avoid this.

      expectClientErrors(link).toEqual("pending");
      node = (0, _shapedTree.forgetShape)(link.formState[1]);
      expect(node.data.meta.succeeded).toBe(false);
      expectMetaTouched(node.data.meta, false); // After the second render the error arrives.

      link = renderFn.mock.calls[1][0];
      expectClientErrors(link).toEqual(["error a"]);
      node = (0, _shapedTree.forgetShape)(link.formState[1]);
      expect(node.data.meta.succeeded).toBe(false);
      expectMetaTouched(node.data.meta, false);
      expect(validationA).toHaveBeenCalledTimes(1);
      expect(validationA).toHaveBeenCalledWith("hello"); // When a new Field is mounted, we expect the new errors to show up.

      renderFn.mockClear();
      validationA.mockClear();
      renderer.update(React.createElement(_Form.default, {
        initialValue: {
          key: "hello"
        }
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link
        }, function (link) {
          return React.createElement(React.Fragment, null, React.createElement(_LinkTap.default, {
            link: link.key
          }, renderFn), React.createElement(_TestField.default, {
            link: link.key,
            validation: validationA
          }), React.createElement(_TestField.default, {
            link: link.key,
            validation: validationB
          }));
        });
      }));
      expect(renderFn).toHaveBeenCalledTimes(2); // There's an initial render where the field hasn't yet been validated
      // TODO(dmnd): It'd be nice if we could avoid this.

      link = renderFn.mock.calls[0][0];
      expectClientErrors(link).toEqual(["error a"]);
      node = (0, _shapedTree.forgetShape)(link.formState[1]);
      expect(node.data.meta.succeeded).toBe(false);
      expectMetaTouched(node.data.meta, false); // After the update, the new error should be present.

      link = renderFn.mock.calls[1][0];
      expectClientErrors(link).toEqual(["error a", "error b"]);
      node = (0, _shapedTree.forgetShape)(link.formState[1]);
      expect(node.data.meta.succeeded).toBe(false);
      expectMetaTouched(node.data.meta, false); // Validation functions should receive the correct parameters. These
      // assertions protect against bugs that confuse relative and absolute
      // paths/values.

      expect(validationA).toHaveBeenCalledTimes(1);
      expect(validationA).toHaveBeenCalledWith("hello");
      expect(validationB).toHaveBeenCalledTimes(1);
      expect(validationB).toHaveBeenCalledWith("hello");
    });
    it("updates errors when a new validation function is provided via props", function () {
      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: "hello"
      }, function (link) {
        return React.createElement(_TestField.default, {
          link: link,
          validation: function validation() {
            return ["error 1"];
          }
        });
      }));

      var link = renderer.root.findAllByType(_TestField.default)[0].instance.props.link;
      var errors = link.formState[1].data.errors.client;
      expect(errors).toEqual(["error 1"]);
      renderer.update(React.createElement(_Form.default, {
        initialValue: "hello"
      }, function (link) {
        return React.createElement(_TestField.default, {
          link: link,
          validation: function validation() {
            return ["error 2"];
          }
        });
      }));
      link = renderer.root.findAllByType(_TestField.default)[0].instance.props.link;
      errors = link.formState[1].data.errors.client;
      expect(errors).toEqual(["error 2"]);
    });
  });
  describe("Form manages form state", function () {
    it("creates the initial formState from initialValue and externalErrors", function () {
      var onSubmit = jest.fn();
      var renderFn = jest.fn(function () {
        return null;
      });

      _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: 1,
        onSubmit: onSubmit,
        externalErrors: {
          "/": ["External error", "Another external error"]
        }
      }, renderFn));

      expect(renderFn).toHaveBeenCalled();
      var link = renderFn.mock.calls[0][0];
      (0, _tools.expectLink)(link);

      var _link$formState = _slicedToArray(link.formState, 2),
          value = _link$formState[0],
          tree = _link$formState[1];

      expect(value).toBe(1);
      expect((0, _shapedTree.forgetShape)(tree).type).toBe("leaf");
      expect((0, _shapedTree.forgetShape)(tree).data).toEqual({
        meta: {
          touched: false,
          changed: false,
          succeeded: false,
          asyncValidationInFlight: false
        },
        errors: {
          client: "pending",
          external: ["External error", "Another external error"]
        }
      });
    });
    it("parses and sets complex external errors", function () {
      var onSubmit = jest.fn();
      var renderFn = jest.fn(function () {
        return null;
      });

      _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          simple: 3,
          complex: [{
            inner: "hello"
          }, {
            inner: "there"
          }]
        },
        onSubmit: onSubmit,
        externalErrors: {
          "/": ["Root error"],
          "/simple": ["One", "level", "down"],
          "/complex": [],
          "/complex/0": ["in an", "array"]
        }
      }, renderFn));

      expect(renderFn).toHaveBeenCalled();
      var link = renderFn.mock.calls[0][0];
      (0, _tools.expectLink)(link);

      var _link$formState2 = _slicedToArray(link.formState, 2),
          _ = _link$formState2[0],
          tree = _link$formState2[1]; // Cross your fingers


      var root = tree;
      expect(root.data.errors.external).toEqual(["Root error"]);
      var simple = root.children.simple;
      expect(simple.data.errors.external).toEqual(["One", "level", "down"]);
      var complex = root.children.complex;
      expect(complex.data.errors.external).toEqual([]);
      var complex0 = complex.children[0];
      expect(complex0.data.errors.external).toEqual(["in an", "array"]);
      var complex1 = complex.children[1];
      expect(complex1.data.errors.external).toEqual([]);
    });
    it("updates the external errors", function () {
      var onSubmit = jest.fn();
      var renderFn = jest.fn(function () {
        return null;
      });

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          array: []
        },
        onSubmit: onSubmit,
        externalErrors: {
          "/array": ["Cannot be empty"]
        }
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link
        }, renderFn);
      }));

      expect(renderFn).toHaveBeenCalled();
      var links = renderFn.mock.calls[0][0];
      var newFormState = (0, _tools.mockFormState)([1]);
      links.array.onChange(newFormState);
      var anotherRenderFn = jest.fn();
      renderer.update(React.createElement(_Form.default, {
        initialValue: {
          array: []
        },
        onSubmit: onSubmit,
        externalErrors: {
          "/array": [],
          "/array/0": ["inner error"]
        }
      }, anotherRenderFn));
      expect(anotherRenderFn).toHaveBeenCalled();
      var link = anotherRenderFn.mock.calls[0][0];

      var _link$formState3 = _slicedToArray(link.formState, 2),
          _ = _link$formState3[0],
          tree = _link$formState3[1]; // Cross your fingers


      var root = tree;
      expect(root.data.errors.external).toEqual([]);
      var array = root.children.array;
      expect(array.data.errors.external).toEqual([]);
      var array0 = array.children[0];
      expect(array0.data.errors.external).toEqual(["inner error"]);
    });
    it("doesn't cause an infinite loop when using inline validation function", function () {
      expect(function () {
        _reactTestRenderer.default.create(React.createElement(_Form.default, {
          initialValue: "hello"
        }, function (link) {
          return React.createElement(_TestField.default, {
            link: link,
            validation: function validation() {
              return [];
            }
          });
        }));
      }).not.toThrow(/Maximum update depth exceeded/);
    });
    it("collects the initial validations", function () {
      // This test is not very unit-y, but that's okay! It's more useful to
      // know that it's working with ArrayField and ObjectField and Field
      var onSubmit = jest.fn();

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          errors: "foo",
          noErrors: "bar",
          array: ["baz", "quux"]
        },
        onSubmit: onSubmit
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link,
          validation: function validation() {
            return ["Toplevel error"];
          }
        }, function (link) {
          return React.createElement(React.Fragment, null, React.createElement(_TestField.default, {
            link: link.errors,
            validation: function validation() {
              return ["Two", "errors"];
            }
          }), React.createElement(_TestField.default, {
            link: link.noErrors
          }), React.createElement(_ArrayField.default, {
            link: link.array,
            validation: function validation() {
              return ["Array errors"];
            }
          }, function (links) {
            return links.map(function (link, i) {
              return React.createElement(_TestField.default, {
                key: i,
                link: link,
                validation: i === 1 ? function () {
                  return ["Errors on the second item"];
                } : function () {
                  return [];
                }
              });
            });
          }));
        });
      })); // Cross your fingers


      var root = (0, _shapedTree.forgetShape)(renderer.root.instance.state.formState[1]);
      expect(root.data.errors.client).toEqual(["Toplevel error"]);
      expect(root.data.meta).toMatchObject({
        succeeded: false
      });
      var errors = root.children.errors;
      expect(errors.data.errors.client).toEqual(["Two", "errors"]);
      var noErrors = root.children.noErrors;
      expect(noErrors.data.errors.client).toEqual([]);
      expect(noErrors.data.meta).toMatchObject({
        succeeded: true
      });
      var array = root.children.array;
      expect(array.data.errors.client).toEqual(["Array errors"]);
      var array0 = array.children[0];
      expect(array0.data.errors.client).toEqual([]);
      var array1 = array.children[1];
      expect(array1.data.errors.client).toEqual(["Errors on the second item"]);
    });
    it("doesn't break on validation when given an input with bad behaviour", function () {
      var onSubmit = jest.fn();

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          naughty: "foo",
          nice: "bar"
        },
        onSubmit: onSubmit
      }, function (link) {
        return React.createElement(_ObjectField.default, {
          link: link,
          validation: function validation() {
            return ["Toplevel error"];
          }
        }, function (link) {
          return React.createElement(React.Fragment, null, React.createElement(NaughtyRenderingField, {
            link: link.naughty,
            validation: function validation() {
              return ["Naughty", "errors"];
            }
          }), React.createElement(_TestField.default, {
            link: link.nice,
            validation: function validation() {
              return ["Nice", "errors"];
            }
          }));
        });
      }));

      var formState = renderer.root.instance.state.formState;
      expect(formState[0]).toEqual({
        naughty: "hello from cDM()",
        nice: "bar"
      }); // Cross your fingers

      var root = formState[1];
      expect(root.data.errors.client).toEqual(["Toplevel error"]);
      var naughty = root.children.naughty;
      expect(naughty.data.errors.client).toEqual(["Naughty", "errors"]);
      var nice = root.children.nice;
      expect(nice.data.errors.client).toEqual(["Nice", "errors"]);
    });
    it("changes when link calls onChange", function () {
      var onSubmit = jest.fn();
      var renderFn = jest.fn(function () {
        return null;
      });

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: 1,
        onSubmit: onSubmit
      }, renderFn));

      var link = renderFn.mock.calls[0][0];
      var newFormState = (0, _tools.mockFormState)(2);
      link.onChange(newFormState);
      expect(renderer.root.instance.state.formState).toBe(newFormState);
    });
    it("changes when link calls onBlur", function () {
      var onSubmit = jest.fn();
      var renderFn = jest.fn(function () {
        return null;
      });

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: 1,
        onSubmit: onSubmit
      }, renderFn));

      var link = renderFn.mock.calls[0][0];

      var _mockFormState = (0, _tools.mockFormState)(2),
          _mockFormState2 = _slicedToArray(_mockFormState, 2),
          _ = _mockFormState2[0],
          newTree = _mockFormState2[1];

      link.onBlur(newTree);
      expect(renderer.root.instance.state.formState[1]).toBe(newTree);
    });
  });
  describe("Form manages form-level meta information", function () {
    it("tracks whether the form has been modified", function () {
      var onSubmit = jest.fn();
      var contextExtractor = jest.fn(function () {
        return null;
      });
      var renderFn = jest.fn(function () {
        return React.createElement(_Form.FormContext.Consumer, null, contextExtractor);
      });

      _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: 1,
        onSubmit: onSubmit
      }, renderFn));

      expect(contextExtractor).toHaveBeenCalledWith(expect.objectContaining({
        pristine: true
      }));
      var link = renderFn.mock.calls[0][0];
      var nextFormState = (0, _tools.mockFormState)(2);
      link.onChange(nextFormState);
      expect(contextExtractor).toHaveBeenLastCalledWith(expect.objectContaining({
        pristine: false
      }));
    });
    it("tracks whether the form has been submitted", function () {
      var contextExtractor = jest.fn(function () {
        return null;
      });
      var renderFn = jest.fn(function () {
        return React.createElement(_Form.FormContext.Consumer, null, contextExtractor);
      });

      _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: 1,
        onSubmit: jest.fn()
      }, renderFn));

      expect(contextExtractor).toHaveBeenCalledWith(expect.objectContaining({
        submitted: false
      }));
      var onSubmit = renderFn.mock.calls[0][1];
      onSubmit();
      expect(contextExtractor).toHaveBeenLastCalledWith(expect.objectContaining({
        submitted: true
      }));
    });
    it("gives children a shouldShowError", function () {
      var onSubmit = jest.fn();
      var contextExtractor = jest.fn(function () {
        return null;
      });

      var renderFn = function renderFn() {
        return React.createElement(_Form.FormContext.Consumer, null, contextExtractor);
      };

      _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: 1,
        onSubmit: onSubmit
      }, renderFn));

      expect(contextExtractor).toHaveBeenCalledWith(expect.objectContaining({
        shouldShowError: expect.any(Function)
      }));
    });
    it("Passes additional information to its render function", function () {
      var renderFn = jest.fn(function () {
        return null;
      });

      _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: 1,
        feedbackStrategy: _feedbackStrategies.default.Touched,
        onSubmit: jest.fn(),
        externalErrors: {
          "/": ["External error", "Another external error"]
        }
      }, renderFn));

      expect(renderFn).toHaveBeenCalledWith(expect.anything(), expect.anything(), expect.objectContaining({
        touched: false,
        changed: false,
        shouldShowErrors: false,
        unfilteredErrors: expect.arrayContaining(["External error", "Another external error"]),
        // Currently, only care about client errors
        valid: true,
        asyncValidationInFlight: false,
        value: 1
      }));
    });
    it("removes errors when a child unmounts", function () {
      var validation1 = jest.fn(function () {
        return ["error 1"];
      });
      var validation2 = jest.fn(function () {
        return ["error 2"];
      });

      var TestForm =
      /*#__PURE__*/
      function (_React$Component2) {
        _inherits(TestForm, _React$Component2);

        function TestForm() {
          _classCallCheck(this, TestForm);

          return _possibleConstructorReturn(this, _getPrototypeOf(TestForm).apply(this, arguments));
        }

        _createClass(TestForm, [{
          key: "render",
          value: function render() {
            var _this = this;

            return React.createElement(_ObjectField.default, {
              link: this.props.link
            }, function (links) {
              return React.createElement(React.Fragment, null, React.createElement(_TestField.default, {
                key: "1",
                link: links.string1,
                validation: validation1
              }), _this.props.hideSecondField ? null : React.createElement(_TestField.default, {
                key: "2",
                link: links.string2,
                validation: validation2
              }));
            });
          }
        }]);

        return TestForm;
      }(React.Component);

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: {
          string1: "hello",
          string2: "world"
        }
      }, function (link) {
        return React.createElement(TestForm, {
          link: link,
          hideSecondField: false
        });
      }));

      expect(validation1).toHaveBeenCalledTimes(1);
      expect(validation2).toHaveBeenCalledTimes(1);
      var rootFormState = renderer.root.findByType(TestForm).instance.props.link.formState[1];
      var string1Errors = rootFormState.children.string1.data.errors.client;
      expect(string1Errors).toEqual(["error 1"]);
      var string2Errors = rootFormState.children.string2.data.errors.client;
      expect(string2Errors).toEqual(["error 2"]); // now hide the second field, causing it to unmount and unregister the
      // validation handler

      renderer.update(React.createElement(_Form.default, {
        initialValue: {
          string1: "hello",
          string2: "world"
        }
      }, function (link) {
        return React.createElement(TestForm, {
          link: link,
          hideSecondField: true
        });
      })); // no addition validation calls

      expect(validation1).toHaveBeenCalledTimes(1);
      expect(validation2).toHaveBeenCalledTimes(1);
      rootFormState = renderer.root.findByType(TestForm).instance.props.link.formState[1]; // error for string1 remains

      string1Errors = rootFormState.children.string1.data.errors.client;
      expect(string1Errors).toEqual(["error 1"]); // string2's error is gone

      string2Errors = rootFormState.children.string2.data.errors.client;
      expect(string2Errors).toEqual([]);
    });
    it("runs all validations when a link has multiple fields", function () {
      var validation1 = jest.fn(function () {
        return ["error 1"];
      });
      var validation2 = jest.fn(function () {
        return ["error 2"];
      });

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: "hello"
      }, function (link) {
        return React.createElement(React.Fragment, null, React.createElement(_TestField.default, {
          key: "1",
          link: link,
          validation: validation1
        }), React.createElement(_TestField.default, {
          key: "2",
          link: link,
          validation: validation2
        }));
      }));

      expect(validation1).toHaveBeenCalledTimes(1);
      expect(validation2).toHaveBeenCalledTimes(1);
      renderer.root.findAllByType(_TestField.TestInput)[0].instance.change("dmnd");
      expect(validation1).toHaveBeenCalledTimes(2);
      expect(validation2).toHaveBeenCalledTimes(2);
      renderer.root.findAllByType(_TestField.TestInput)[1].instance.change("zach");
      expect(validation1).toHaveBeenCalledTimes(3);
      expect(validation2).toHaveBeenCalledTimes(3);
    });
    it("only removes errors from validation that was unmounted", function () {
      var validation1 = jest.fn(function () {
        return ["error 1"];
      });
      var validation2 = jest.fn(function () {
        return ["error 2"];
      });

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: "hello"
      }, function (link) {
        return React.createElement(React.Fragment, null, React.createElement(_TestField.default, {
          key: "1",
          link: link,
          validation: validation1
        }), React.createElement(_TestField.default, {
          key: "2",
          link: link,
          validation: validation2
        }));
      }));

      var link = renderer.root.findAllByType(_TestField.default)[0].instance.props.link;
      var errors = link.formState[1].data.errors.client;
      expect(errors).toEqual(["error 1", "error 2"]);
      renderer.update(React.createElement(_Form.default, {
        initialValue: "hello"
      }, function (link) {
        return React.createElement(React.Fragment, null, React.createElement(_TestField.default, {
          key: "1",
          link: link,
          validation: validation1
        }));
      }));
      link = renderer.root.findAllByType(_TestField.default)[0].instance.props.link;
      errors = link.formState[1].data.errors.client;
      expect(errors).toEqual(["error 1"]);
    });
  });
  it("Calls onSubmit with the value when submitted", function () {
    var onSubmit = jest.fn();
    var contextExtractor = jest.fn(function () {
      return null;
    });
    var renderFn = jest.fn(function () {
      return React.createElement(_Form.FormContext.Consumer, null, contextExtractor);
    });

    _reactTestRenderer.default.create(React.createElement(_Form.default, {
      initialValue: 1,
      onSubmit: onSubmit
    }, renderFn));

    expect(onSubmit).toHaveBeenCalledTimes(0);
    var linkOnSubmit = renderFn.mock.calls[0][1];
    linkOnSubmit();
    expect(onSubmit).toHaveBeenCalledTimes(1);
    expect(onSubmit).toHaveBeenLastCalledWith(1, undefined);
  });
  it("Calls onSubmit with extra info when submitted", function () {
    var onSubmit = jest.fn();
    var renderFn = jest.fn();

    _reactTestRenderer.default.create(React.createElement(_Form.default, {
      initialValue: 1,
      onSubmit: onSubmit
    }, renderFn));

    expect(onSubmit).toHaveBeenCalledTimes(0);
    var linkOnSubmit = renderFn.mock.calls[0][1];
    linkOnSubmit("extra");
    expect(onSubmit).toHaveBeenCalledTimes(1);
    expect(onSubmit).toHaveBeenLastCalledWith(expect.anything(), "extra");
  });
  it("Enforces types on onSubmit", function () {
    var onSubmit = function onSubmit() {};

    _reactTestRenderer.default.create(React.createElement(_Form.default, {
      initialValue: 1,
      onSubmit: onSubmit
    }, function (_, onSubmit) {
      return React.createElement("button", {
        onClick: function onClick() {
          // $ExpectError
          onSubmit(); // $ExpectError

          onSubmit("hello");
          onSubmit("extra");
        }
      });
    }));
  });
  it("Calls onChange when the value is changed", function () {
    var onChange = jest.fn();
    var renderFn = jest.fn(function () {
      return null;
    });

    _reactTestRenderer.default.create(React.createElement(_Form.default, {
      initialValue: 1,
      onChange: onChange
    }, renderFn));

    var link = renderFn.mock.calls[0][0];
    var nextFormState = (0, _tools.mockFormState)(2);
    link.onChange(nextFormState);
    expect(onChange).toHaveBeenCalledWith(2);
  });
  it("Calls onValidation when a part of the value is validated", function () {
    var onValidation = jest.fn();

    var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
      initialValue: "",
      onValidation: onValidation
    }, function (link) {
      return React.createElement(_TestField.default, {
        link: link,
        validation: function validation(s) {
          if (s.length > 0) {
            return [];
          } else {
            return ["No blank strings"];
          }
        }
      });
    }));

    expect(onValidation).toHaveBeenCalledTimes(1);
    expect(onValidation).toHaveBeenLastCalledWith(false);
    var inner = renderer.root.findByType(_TestField.TestInput);
    inner.instance.change("zach");
    expect(onValidation).toHaveBeenCalledTimes(2);
    expect(onValidation).toHaveBeenLastCalledWith(true);
  });
  describe("performance", function () {
    it("batches setState calls when unmounting components", function () {
      // Record the number of render and commit phases
      var renders = 0;
      var commits = 0;

      var RenderCalls =
      /*#__PURE__*/
      function (_React$Component3) {
        _inherits(RenderCalls, _React$Component3);

        function RenderCalls() {
          _classCallCheck(this, RenderCalls);

          return _possibleConstructorReturn(this, _getPrototypeOf(RenderCalls).apply(this, arguments));
        }

        _createClass(RenderCalls, [{
          key: "componentDidUpdate",
          value: function componentDidUpdate() {
            commits += 1;
          }
        }, {
          key: "render",
          value: function render() {
            renders += 1;
            return React.createElement("div", null, "Rendered ", renders, " times, committed ", commits, " times.");
          }
        }]);

        return RenderCalls;
      }(React.Component);

      var validation = jest.fn(); // N in the O(N) sense for this perf test.

      var N = 10;

      var renderer = _reactTestRenderer.default.create(React.createElement(_Form.default, {
        initialValue: "A string"
      }, function (link) {
        return React.createElement(React.Fragment, null, React.createElement(RenderCalls, null), React.createElement(React.Fragment, null, _toConsumableArray(Array(N).keys()).map(function (i) {
          return React.createElement(_Field.default, {
            key: i,
            link: link,
            validation: validation
          }, function () {
            return React.createElement("div", null, "input");
          });
        })));
      })); // One render for initial mount, and another after Form validates
      // everything from componentDidMount.
      // TODO(dmnd): Can we adjust implementation to make this only render once?


      expect(renders).toBe(1 + 1);
      expect(commits).toBe(1);
      expect(validation).toBeCalledTimes(N);
      renders = 0;
      commits = 0;
      validation.mockClear(); // now unmount all the fields

      renderer.update(React.createElement(_Form.default, {
        initialValue: "A string"
      }, function () {
        return React.createElement(React.Fragment, null, React.createElement(RenderCalls, null));
      })); // We expect only two renders. The first to build the VDOM without Fields.
      // Then during reconciliation React realizes the Fields have to unmount,
      // so it calls componentWillUnmount on each Field, which then causes a
      // setState for each Field. But then we expect that React batches all
      // these setStates into a single render, not one render per each Field.

      expect(renders).toBe(1 + 1);
      expect(renders).not.toBe(1 + N); // Similarly, we expect only 2 commits, not one for each Field. You might
      // expect only a single commit, but componentWillUnmount happens during
      // the commit phase, so when setState is called React enqueues another
      // render phase which commits separately. Oh well. At least the number of
      // commits is constant!

      expect(commits).toBe(1 + 1);
      expect(commits).not.toBe(1 + N);
    });
  });
});