"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mockFormState = mockFormState;
exports.expectLink = expectLink;
exports.mockLink = mockLink;

var _shapedTree = require("../shapedTree");

var _types = require("../types");

function mockFormState(value) {
  return [value, (0, _shapedTree.treeFromValue)(value, {
    errors: _types.cleanErrors,
    meta: _types.cleanMeta
  })];
}

function expectLink(link) {
  expect(link).toEqual(expect.objectContaining({
    // TODO(dmnd): Would be nice if we could do something like
    // path: expect.arrayContaining(
    //   expect.objectContaining({
    //     type: expect.stringMatching(/(object)|(array)/),
    //   })
    // ),
    path: expect.anything(),
    formState: expect.anything(),
    onChange: expect.any(Function),
    onBlur: expect.any(Function)
  }));
  expect(Object.keys(link).length).toBe(4);
}

function mockLink(formState) {
  return {
    path: [],
    formState: formState,
    onChange: jest.fn(),
    onBlur: jest.fn()
  };
}