"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zipWith = zipWith;

var _set = require("./set");

function zipWith(f, left, right) {
  var leftKeys = new Set(Object.keys(left));
  var rightKeys = new Set(Object.keys(right));

  if (!(0, _set.setEq)(leftKeys, rightKeys)) {
    throw new Error("Tried to zip two object with different keys");
  }

  return Object.keys(left).reduce(function (memo, k) {
    memo[k] = f(left[k], right[k]);
    return memo;
  }, {});
}